#include <stdio.h>
/*
 * Simplex Mesh Function Visualizer API for gltools.
 * Derived from old gltensview
 * Has F77 API.
 */


typedef  double (*glsxvFunc)(double  x, double  y, double  z,double t);
typedef void (*glsxvFlux)(double x, double y, double z, double t,double*v);
typedef struct gl_simplex_mesh_struct *GLSimplexMesh;


GLSimplexMesh glsxvCreate(int dim,
			  int nnodes,
			  int ncells,
			  int *sxlist,
			  double *xc,
			  double *yc, 
			  double *zc);


void glsxvSetTitle(GLSimplexMesh m, char *title);
void glsxvSetBox(GLSimplexMesh m, double xmin, double xmax, double ymin, double ymax,double zmin,double zmax);
void glsxvDestroy(GLSimplexMesh m);
void glsxvCalcNodeFunc(GLSimplexMesh m,glsxvFunc f, double t);
void glsxvCalcCellflux(GLSimplexMesh m, glsxvFlux f,double t);


int glsxvData(GLSimplexMesh m);
int glsxvNodeFuncf(GLSimplexMesh m,glsxvFunc f, double t, double fmin, double fmax);
int glsxvCellFluxf(GLSimplexMesh m,glsxvFlux f, double t, double fmin, double fmax);
int glsxvNodeFuncv(GLSimplexMesh m, double *f, double t, double fmin, double fmax);
int glsxvCellFluxv(GLSimplexMesh m,double *f, double t, double fmin, double fmax);

#ifdef fortran 
#define F77(x) x
#else
#define F77(x) x##_
#endif

void F77(glsxv_create)(int *dim, int *nnodes, int *ncells, int *sxlist, double *xc,double *yc,double *zc, int *handle);
void F77(glsxv_destroy)(int *handle);
void F77(glsxv_node_func)(int *handle, double *f, double *t, double *fmin, double *fmax);
void F77(glsxv_cell_flux)(int *handle, double *f, double *t, double *fmin, double *fmax);
void F77(glsxv_title)(int *handle, char *title, int *l_title);
void F77(glsxv_box)(int *handle, 
		    double *xmin, double *xmax,
		    double *ymin, double *ymax,
		    double *zmin, double *zmax);

/* Subroutine headers for fortran freaks:
	SUBROUTINE glsxv_create(dim,nnodes,ncells,sxlist,xc,yc,zc,handle)
	integer*4 dim,nnodes,ncells, sxlist((dim+1)*ncells)
	real *8 xc(nnodes), yc(nnodes),zc(nnodes)
	integer handle
	end

	SUBROUTINE glsxv_box(handle,xmin,xmax,ymin,ymax,zmin,zmax)
	integer*4 handle
	real *8 xmin,xmax,ymin,ymax,zmin,zmax
	end

	SUBROUTINE glsxv_destroy(handle)
	end

	SUBROUTINE glsxv_node_func(handle, f,time,fmin,fmax)
	integer *4 handle
	real*8 time,fmin,fmax
	real*8 f(nnodes)
	end

	SUBROUTINE glsxv_cell_flux(handle, f,time,fmin,fmax)
	integer *4 handle
	real*8 time,fmin,fmax
	real*8 f(nnodes)
	end

	SUBROUTINE glsxv_title(handle, title, l_title)
	integer *4 handle
	integer*4 title(l_title),l_title
	end

 */

/*
 *  $Log: glsimplexview.h,v $
 *  Revision 1.3  2003/03/28 16:47:48  fuhrmann
 *  pdelib1.15_alpha1
 *
 *  Revision 1.2  2003/03/28 11:20:25  fuhrmann
 *  pdelib2.0_alpha1
 *
 *  Revision 1.1  2002/05/24 16:46:57  fuhrmann
 *  1. glsimplexview version an Klaus
 *
 *
 */
